#include "FrameControl.h"

FrameControl::FrameControl (DWORD fps) {
	// ftHgł͈b(~b)60t[
	m_frameTime = 1000.0f / fps;
	m_frameCount = 0;
	m_fpsCount = 0;
	m_fpsTime = 0;
	timeBeginPeriod(1);
}

FrameControl::~FrameControl () {
	timeEndPeriod(1);
}

void FrameControl::Start () {
	m_beforeTime = timeGetTime();
	m_frameCount++;
}

void FrameControl::End () {
	while ( timeGetTime() - m_beforeTime < m_frameTime ) {
	    Sleep(1);
	}

	if(timeGetTime() - m_fpsTime >= 1000){
		m_fpsTime = timeGetTime();
		m_fpsCount = m_frameCount;
		m_frameCount = 0;
	}
}

int FrameControl::GetFPS() const {
	return m_fpsCount;
}

const TCHAR* FrameControl::GetFPS(const TCHAR* format) {
	wsprintf(m_fpsStr,format,m_fpsCount);
	return m_fpsStr;
}
