#ifndef _YDINPUT8_H
#define _YDINPUT8_H

#define DIRECTINPUT_VERSION 0x0800						// DirectInputo[Ww
#include <dinput.h>

#pragma comment( lib, "dinput8.lib" )
#pragma comment( lib, "dxguid.lib" )

#define ANALOG_DEPTH	1000							// AiOWCXeBbNғ͈

// WCXeBbN
typedef struct _CDIJOYSTICK {
	LPDIRECTINPUTDEVICE8	lpJoyDev;					// WCXeBbNfBoCX
	WCHAR					mInstName[MAX_PATH];		// CX^X
	WCHAR					mProdName[MAX_PATH];		// i
} CDIJOYSTICK, *LPCDIJOYSTICK;


class CYDInput8
{
protected:
	HINSTANCE				m_hInst;
	HWND					m_hWnd;
	LPDIRECTINPUT8			m_lpDI;						// DirectInputIuWFNg
	LPDIRECTINPUTDEVICE8	m_lpKeyboard;				// L[{[hfoCX
	int						m_iJoy;						// WCXeBbN̐
	LPCDIJOYSTICK			m_mJoy;						// WCXeBbN

private:
	static BOOL CALLBACK EnumJoyDeviceProc( LPDIDEVICEINSTANCE lpddi, LPVOID pvRef );

public:
	CYDInput8();
	virtual ~CYDInput8();
	BOOL Create( HWND hWnd, HINSTANCE hInst );			// \z
	BOOL Delete();										// I

public:
	BOOL CreateKeyboard();								// L[{[h
	BOOL GetKeyboard( LPBYTE key );						// L[{[h̏ԂԂ(CreateKeyboardĂȂꍇ̓G~)
	BOOL StartKeyBoard();								// L[{[h擾Jn
	BOOL StopKeyBoard();

public:
	BOOL CreateJoystick();								// SWCXeBbN
	BOOL StartJoystick();								// WCXeBbN擾Jn
	BOOL StopJoystick();
	BOOL GetJoystick( LPDIJOYSTATE2 js );				// SWCXeBbN(WCXeBbNDIJOYSTATE2w)
	BOOL GetJoystick( LPDIJOYSTATE2 js, int id );		// WCXeBbN̏P擾(1DIJOYSTATE2w)
	WCHAR *GetJoyInstName( int id );						// wID̃CX^XԂ
	WCHAR *GetJoyProdName( int id );						// wID̐iԂ
	inline int GetJoyNum( void ) { return m_iJoy; }		// ڑĂWCXeBbN̐Ԃ

};

typedef CYDInput8	CYDInput,CYDINPUT,*LPCDYINPUT;

#endif