#ifndef _FRAME_CONTROL_H
#define _FRAME_CONTROL_H

#include <windows.h>
#include <mmsystem.h>

class FrameControl {
private:
	int m_fps;
	int m_frameCount;
	int m_fpsCount;
	TCHAR m_fpsStr[64];
	DWORD m_beforeTime;
	DWORD m_fpsTime;
	float m_frameTime;
 public:
 	FrameControl (DWORD fps = 60);
 	~FrameControl ();
 	void Start();
 	void End();
 	int GetFPS() const;
 	const TCHAR* GetFPS(const TCHAR* format);
};

#endif