/*
 * csaori.h
 * 
 * written by Ukiya http://ukiya.sakura.ne.jp/
 * based by тl "gethwnd.dll"
 */

#pragma once

#define SAORIAPI extern "C" __declspec(dllexport)

#define SAORICDECL __cdecl

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <string>
#include <vector>
#include <map>
#include <TCHAR.H>
#include <process.h>

#include "csaori.h"

#include "YDInput8.h"
#include "FrameControl.h"

//DLLMain
HANDLE	StrToHandle( LPCTSTR sHand );	// 񁄃nhϊ
int		StrToKeycode( string_t Str );	// 񁄃L[R[hϊ


#define DEFAULT_ANALOG_MARGIN		200

typedef enum { KS_NONE, KS_DOWN, KS_PRESS, KS_UP } KEYSTATE;

class CSAORIDi : public CSAORI {
	HWND			*m_phWnd;							// o^EBhEnh
	int				m_RegistWndNum;						// o^EBhEnh
	HINSTANCE		m_hInst;							// DLLCX^X
	CYDInput8		*m_pDInput;							// DIIuWFNg
//	int				m_RegistKeyNum;						// o^L[
//	short			*m_pKeyCodeList;					// o^L[R[hXg
	HANDLE			m_hThread;							// Xbhnh
	volatile int	m_bThLoopFlag;						// Xbh[vtO
	SAORI_FUNC::CCriticalSection m_loopFlagLock;		// Xbh[vtObN
//	BYTE			**m_ppKeyBuf;						// 擾L[obt@
	DIJOYSTATE2		m_JoyBuf[2];						// 擾WCXeBbNobt@
	int				m_CheckButtonNum;					// 擾{^
	int				m_AnalogMargin;						// Vђl

	//SubThread
	BOOL	StartDiProc();								// XbhJn
	BOOL	StopDiProc();								// Xbh~
	void	SetLoopFlag( bool flag );					// [vtOݒ
	bool	GetLoopFlag();								// [vtO擾
	int		KeyStateConvert( BYTE now, BYTE old );		// L[Ԏ擾lϊ
	unsigned static __stdcall StartThread( void *p );	// Xbhbp[
	unsigned diThread();								// 擾Xbh[v{
	bool	CheckWindowActive();						// ANeBuEBhE`FbN
	int		CheckMargin( int margin );					// AiOo[Vѓ̓`FbN
	int		MarginProc( int in, int margin );			// AiOVѕ␳

public:
	CSAORIDi(void) { }
	virtual ~CSAORIDi() { }

	//ȉׂ֐
	void exec(const CSAORIInput& in,CSAORIOutput& out);
	bool unload();
	bool load();

};
